<?php

//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// $Id: parse_output.php,v 1.12 2002/12/01 12:30:18 friedl Exp $
// File: parse_output.php
// Function: convert text output from ipacsum into html-table
//           

function parse_output($input, $content) {
    global $text;
    $traffic = array();

    $input_ar = explode("\n",$input);

    while ($line = each($input_ar)) {
        if (eregi("Host: (.*) / Time created: (.*)$",$line[1], $regs)) {
	    $host = $regs[1];
	    $create_time = $regs[2];
	    continue;
	}
	if (eregi("Data from (.*) to (.*)$", $line[1], $regs)) {
	    $data_from = $regs[1];
	    $data_to = $regs[2];
	    continue;
	}
	if (eregi("^(\*)? ([a-zA-Z0-9\\_\. <>-]*):(.*)$",$line[1],$regs)) {
	    $rule = trim($regs[2]);
	    $vol = trim($regs[3]);
	    $new = trim($regs[1]);
	    $traffic[$rule] = array('traffic' => $vol,
				    'new'     => $new
				   );
	    if ($new == "*") {
		$incomplete_msg = 1;
	    }
	}
    }
    
    $code = <<<EOD
<table border="0" width="100%">
<tr>
    <td align="center" width="50%">
	<table width="90%">
	<tr>
	    <td>{$text["hostname"]}</td>
	    <td >$host</td>
	</tr>
	<tr>
	    <td>{$text["create_time"]}</td>
	    <td>$create_time</td>
	</tr>
	<tr>
	    <td>{$text["start_time"]}</td>
	    <td>$data_from</td>
	</tr>
	<tr>
	    <td>{$text["end_time"]}</td>
	    <td>$data_to</td>
	</tr>
	</table>
    </td>
</tr>
<tr>
    <td> &nbsp;
    </td>
</tr>
<tr>
    <td align="center" width="50%" valign="top">
EOD;
    if (count($content['in']) !=  0) {
        $code .= printtable($traffic, $content['in']);
    } else {
	$code .= "<b>".$text["no_input_rules"]."</b>";
    }
    $code .= <<<EOD
    
    </td>
    <td align="center" width="50%" valign="top">
EOD;
    if (count($content['out']) != 0) {
        $code .= printtable($traffic, $content['out']);
    } else {
	$code .= "<b>".$text["no_output_rules"]."</b>";
    }
	
    $code .= <<<EOD

    </td>
</tr>
EOD;
    if ($incomplete_msg == 1) {
	$code .= <<<EOD
<tr>
    <td> &nbsp; </td>
</tr>
<tr> 
    <td width="50%">
	<table width="90%" border="0" align="center">
	<tr>
	    <td>* = {$text['data_incomplete']} </td>
	</tr>
	</table>
    </td>
</tr>
EOD;
    }
    $code .= <<<EOD
</table>
EOD;
    return $code;

}

function artrim(&$value, $key) {
    $value = trim($value);
}

function printtable ($traffic, $content) {
    global $text;
    reset($content);
    $return = <<<EOD

    	<table border="0" width="90%" style="border-collapse:collapse;">
	<tr>
	    <td style="text-align:left;border-bottom:1px solid black">{$text['rule']}</td>
	    <td style="text-align:right;border-bottom:1px solid black">{$text['traffic']}</td>
	</tr>  
EOD;
    while ($item = each($content)) {
	$html_rule = htmlspecialchars($item[1]['rule']);
	$traf = $traffic[trim($item[1]['rule'])]['traffic'];
	$return .= <<<EOD
	<tr>
	    <td>{$traffic[$item[1]['rule']]['new']} {$html_rule}
	    </td>
	    <td style="text-align:right">{$traf}
	    </td>
	</tr>
EOD;
    }
    $return .= <<<EOD

    	</table>
EOD;
    return $return;
}


?>
